



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Numpy应用100问</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Numpy应用100问</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 06:02:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　对于从事机器学习的人，python+numpy+scipy+matplotlib是重要的基础；它们基本与matlab相同，而其中最重要的当属numpy；因此，这里列出100个关于numpy函数的问题，希望读者通过&ldquo;题海&rdquo;快速学好numpy；题中示例可以粘贴运行，读者可以边执行边看效果；</p>
<p>1 &nbsp;如何引入numpy？</p>
<p>import numpy as np（或者from numpy import *）</p>
<p>2 &nbsp;如何定义一个数组？</p>
<p>import numpy as np</p>
<p>x = np.array([[1,2,3],[5,6,7],np.int32])</p>
<p>y = x[.,1] &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; # 取出x的一列，y = [2,6]</p>
<p>3 实部和虚部如何提取？</p>
<p>x = np.array([ 1+2j, 3 + 4j, 5+6j] )</p>
<p>&gt;&gt; x.imag &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;# x.imag就是x集合中取出的虚部的集合</p>
<p>&gt;&gt; array([ 2., 4., 6.])</p>
<p>&gt;&gt; x.imag = [4,8,12] &nbsp;# 将集合x.imag一次赋值</p>
<p>4 序列如何排序？</p>
<p>&gt;&gt; x = [3,4,1,2,5]</p>
<p>&gt;&gt; x.argsort()</p>
<p>&gt;&gt; [2,3,0,1,4] &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; # 排序后的序列下标</p>
<p>5 何为矩阵的坐标轴axis=0或axis=1是啥？</p>
<p>axis = 0 是指按照列方向，axis = 1是按照行方向（操作）。</p>
<p>6 如何用choose函数？</p>
<p>&gt;&gt; x = np.arange(25).reshape(5,5) &nbsp; &nbsp; # 定义矩阵x[5][5]</p>
<p>array(&nbsp;[</p>
<p>[ 0, 1, 2, 3, 4],<br />&nbsp; &nbsp;[ 5,  6,  7,  8,  9],<br />&nbsp; &nbsp;[10, 11, 12, 13, 14],<br />&nbsp; &nbsp;[15, 16, 17, 18, 19],<br />&nbsp; &nbsp;[20, 21, 22, 23, 24]</p>
<p>] )</p>
<p>&gt;&gt;np.choose([1,2,1,2,1],x) &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;# 选择x的[1,2,1,2,1]行对应数</p>
<p>&gt;&gt;[5,11,7,13,9]</p>
<p>再如：</p>
<p>a = np.array([[0,1,2],[2,3,0],[1,0,1]])</p>
<p>b = np.array([12,-11,8,7])</p>
<p>np.choose( a, b )</p>
<p>&gt;&gt;</p>
<p>array([[ 12, -11, 8], &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;# 取a的架构，用b的item填写<br />       [  8,   7,  12],<br />       [-11,  12, -11]])</p>
<p>7 &nbsp;何为裁剪clips函数？</p>
<p>是按照一个范围剪切数组；</p>
<p>8 &nbsp;何为all和any函数？</p>
<p>all和any函数测试两个矩阵的元素；当全部相等用all，部分相等用any；</p>
<p>示例：</p>
<p>a = &nbsp;np.arange(15).reshape(3,5)</p>
<p>b = a.copy()</p>
<p>(a ==b).all()</p>
<p>&gt;&gt;True</p>
<p>9 &nbsp;何为argmax和argmin,argsort函数？</p>
<p>argmax和argmin返回矩阵中，最大元或最校元的下标；argsort返回矩阵排序的下标；其中可选坐标横向或纵向；</p>
<p>10 何为compress 函数？</p>
<p>a = &nbsp;np.arange(15).reshape(3,5)</p>
<p>np.compress([True,False,True],a,axis=0) &nbsp; &nbsp;#此处为行方向，取0，2向量构成的矩阵</p>
<p>&gt;&gt;</p>
<p>array([[ 0, 1, 2, 3, 4],<br />       [10, 11, 12, 13, 14]])</p>
<p>11 如何求共轭复数conjugate函数？</p>
<p>np.conjugate（1+3j）</p>
<p>&gt;&gt; 1-3j</p>
<p>12 copy函数是啥？</p>
<p>a = b.copy()或 a = np.copy(b) &nbsp; #生成b的副本，赋值给a</p>
<p>13 何为cumprod乘积？</p>
<p>b = array([3,8,9])</p>
<p>np.cumprod(b) &nbsp; &nbsp; &nbsp; &nbsp;#该乘积是将[a，b，c]转换成[a，a*b，a*b*c]的乘积</p>
<p>&gt;&gt;[3,24,216]</p>
<p>另：</p>
<p>a = array([[1, 2, 3],<br />       [4, 5, 6]])</p>
<p>np.cunprod(a)</p>
<p>&gt;&gt;</p>
<p>array([ 1, 2, 6, 24, 120, 720])</p>
<p>14 何为cumsum和？</p>
<p>array([ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11])</p>
<p>cumsum(b) &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;#累计的和数列，类似于阶乘的数列</p>
<p>array([ 0, 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, 66])</p>
<p>15 何为diagonal函数？</p>
<p>求一个矩阵的主对角元素组成的数列。</p>
<p>a = array([[ 0, 1, 2, 3, 4],<br />       [ 5,  6,  7,  8,  9],<br />       [10, 11, 12, 13, 14]])</p>
<p>diagonal(a)</p>
<p>&gt;&gt;</p>
<p>array([0,6,12) &nbsp; &nbsp; #注意，不论是否方阵；</p>
<p>16 何为dot函数？</p>
<p>dot是两个矩阵相乘的函数，当矩阵为一维时，是向量内积，二维的是矩阵相乘；</p>
<p>17何为mean函数？</p>
<p>就是对矩阵所有元求平均；</p>
<p>18何为nonzero函数？</p>
<p>nonzero（a）返回a中非零数据项的下标；</p>
<p>a =&nbsp;array([[ 0, 1, 2, 3, 4],</p>
<p>[ 5,  6,  7,  8,  9],<br />       [ 0, 11, 12,  0, 14]])</p>
<p><em>nonzero（a）</em></p>
<p>&gt;&gt;</p>
<p>(array([0, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2], dtype=int64),<br /> array([1, 2, 3, 4, 0, 1, 2, 3, 4, 1, 2, 4], dtype=int64))</p>
<p>另：（a〉3).nonzero() &nbsp; &nbsp; #表示大于3的数的下标</p>
<p>19 何为prod函数？</p>
<p>就是将矩阵所有元素相乘；</p>
<p>a = array([ 0, 1, 2, 3, 4])</p>
<p>prod(a)</p>
<p>&gt;&gt; 24</p>
<p>20 何为ptp函数？</p>
<p>是指矩阵按照某个轴上最大值和最小值得差，即数据gap范围；</p>
<p>21 何为put函数？</p>
<p>将指定下标的元素，赋值为其它值；</p>
<p>22 何为ravel函数？</p>
<p>将矩阵扁平化，即转换成一维排列；参见ndarray的flat和flaten函数；</p>
<p>23 何为repeat函数？</p>
<p>将矩阵每个元素重复n遍，放入一维序列中；</p>
<p>a = array（[[1，2]，[4，5]）</p>
<p>np.repeat(a,2) &nbsp; &nbsp;#将a的元素重复2次</p>
<p>&gt;&gt; array([1,1,2,2,4,4,5,5])</p>
<p>24 何为reshape函数？</p>
<p>将矩阵所有元素重新排列，构成新的矩阵；数据不变；</p>
<p>如：a = np.arange(12).reshape(3,4)</p>
<p>25 何为resize函数？</p>
<p>构成新的矩阵；数据可变；</p>
<p>a = np.array([[1,2,3]])</p>
<p>np.resize(a,[2,3])</p>
<p>&gt;&gt;</p>
<p>array([[1,2,3],[1,2,3]])</p>
<p>26 函数<strong>searchsorted的作用</strong></p>
<p>若存在一个数，和一个排序向量；求该数在排序向量对应的下标；</p>
<p>np.searchsorted([1,2,3,4,5], 3)</p>
<p>&gt;&gt;</p>
<p>2</p>
<p>np.searchsorted([1,2,3,4,5], [3,-1,8])</p>
<p>&gt;&gt;</p>
<p>[2,0,5]</p>
<p>27 函数sort的用法</p>
<p>对矩阵排序，分两种：轴排序，扁平（无轴）排序</p>
<p><strong>&gt;&gt;&gt; </strong>a = np.array([[1,4],[3,1]])<br /><strong>&gt;&gt;&gt; </strong>np.sort(a) &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;<em># sort along the last axis</em><br />array([[1, 4], &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;<br />[1, 3]])<br /><strong>&gt;&gt;&gt; </strong>np.sort(a, axis=None) <em># sort the flattened array</em><br />array([1, 1, 3, 4])<br /><strong>&gt;&gt;&gt; </strong>np.sort(a, axis=0) &nbsp; &nbsp; &nbsp;<em># sort along the first axis</em><br />array([[1, 1],<br />[3, 4]])</p>
<p>28 函数<strong>squeeze</strong>(<em>a</em>)如何用？</p>
<p>将一个具有冗余多维的向量，压缩成一维的向量；</p>
<p><strong>&gt;&gt;&gt; </strong>x = np.array([[[0], [1], [2]]])<br /><strong>&gt;&gt;&gt; </strong>x.shape<br />(1, 3, 1)<br /><strong>&gt;&gt;&gt; </strong>np.squeeze(x).shape<br />(3,)</p>
<p>29 函数std()用法？</p>
<p>对矩阵各元素，求出标准均方差；</p>
<p>30 函数sum()用法？</p>
<p>对矩阵的所有函数进行求和。</p>
<p><strong>&gt;&gt;&gt; </strong>np.sum([0.5, 1.5])</p>
<p>2.0<br /><strong>&gt;&gt;&gt; </strong>np.sum([0.5, 0.7, 0.2, 1.5], dtype=np.int32)<br />1<br /><strong>&gt;&gt;&gt; </strong>np.sum([[0, 1], [0, 5]])<br />6<br /><strong>&gt;&gt;&gt; </strong>np.sum([[0, 1], [0, 5]], axis=0)<br />array([0, 6])<br /><strong>&gt;&gt;&gt; </strong>np.sum([[0, 1], [0, 5]], axis=1)<br />array([1, 5])</p>
<p>31 函数<strong>swapaxes的用法？</strong></p>
<p>swapaxes(): 将n个维度中任意两个维度(坐标轴)进行调换</p>
<p>32 函数take的用法？</p>
<p>numpy.<strong>take</strong>(<em>a</em>, <em>indices</em>, <em>axis=None</em>, <em>out=None</em>, <em>mode=&rsquo;raise&rsquo;</em>)</p>
<p>该函数从a中取出indices下标所对应的元素；</p>
<p><strong>&gt;&gt;&gt; </strong>a = [4, 3, 5, 7, 6, 8]<br /><strong>&gt;&gt;&gt; </strong>indices = [0, 1, 4]<br /><strong>&gt;&gt;&gt; </strong>np.take(a, indices)<br />array([4, 3, 6])</p>
<p>33 函数trace的用途？</p>
<p>numpy.<strong>trace</strong>(<em>a</em>, <em>offset=0</em>, <em>axis1=0</em>, <em>axis2=1</em>, <em>dtype=None</em>, <em>out=None</em>)</p>
<p>求矩阵对角线元素的和；</p>
<p>34 矩阵的<strong>transpose函数？</strong></p>
<p>numpy.<strong>transpose</strong>(<em>a</em>, <em>axes=None</em>)</p>
<p>上述给出a矩阵的转置矩阵；</p>
<p>35 函数var是什么？</p>
<p>numpy.<strong>var</strong>(<em>a</em>, <em>axis=None</em>, <em>dtype=None</em>, <em>out=None</em>, <em>ddof=0</em>)</p>
<p>是求出某个轴向的方差；</p>
<p>36 何为矩阵的切割Slicing？</p>
<p>就是将矩阵通过[i：j：k]转换的新矩阵，i是起始下标，j是终了下标，k是步长；这些下标都能为负；</p>
<p>如：</p>
<p><strong>&gt;&gt;&gt; </strong>x = np.array([0, 1, 2, 3, 4, 5, 6, 7, 8, 9])<br /><strong>&gt;&gt;&gt; </strong>x[1:7:2]<br />array([1, 3, 5])</p>
<p><strong>&gt;&gt;&gt;&nbsp;</strong>x[1:7:1]<br />array([1, 2, 3, 4, 5, 6])</p>
<p>37 如何求一个向量的转置？</p>
<p>a = np.array([1,2,3]) 的转置依旧是它本身</p>
<p>b = np.array([ [1,2,3] ])的转置是</p>
<p>array [[1]，</p>
<p>[2]，</p>
<p>[3]&nbsp;]</p>
<p>要想从a求出列向转置需要:</p>
<p>a[：，np.newaxis ] 这个语法，切记之</p>
<p>38 如何求行向量和列向量之和？</p>
<p>a = np.array([1,2,3])</p>
<p>b =&nbsp;np.array([[x],[y]])</p>
<p>a + b =&nbsp;array([ &nbsp;[1+x,2+x,3+x], [1+y,2+y,3+y] ])这就是规则！</p>
<p>39 如何将数据从文本文件读入？</p>
<p><tt>numpy.</tt><tt>loadtxt</tt><big>(</big><em>fname</em>,&nbsp;<em>dtype=&lt;type 'float'&gt;</em>,&nbsp;<em>comments='#'</em>,&nbsp;<em>delimiter=None</em>,&nbsp;<em>converters=None</em>,&nbsp;<em>skiprows=0</em>,<em>usecols=None</em>,&nbsp;<em>unpack=False</em>,&nbsp;<em>ndmin=0</em><big>)</big><a href="http://github.com/numpy/numpy/blob/v1.11.0/numpy/lib/npyio.py#L682-L966" rel="external nofollow noreferrer">[source]</a></p>
<p>例子：</p>
<p>V1,V2 = np.loadtxt('datas.txt',dtype='float',delimiter=',',skiprows =1,usecols=[1,2],unpack = True)</p>
<pre class="prettyprint linenums">参数解释：</pre>
<p>'datas.txt' ---文件名</p>
<p>dtype='float' ---数据格式</p>
<p>delimiter=',' ---分隔符逗号</p>
<p>skiprows =1 ---跳过第一行</p>
<p>usecols=[1,2] ---选第1，2列读出</p>
<p>unpack = True ---读出两列将拆开，分别给V1和V2</p>
<p>converters=None &nbsp; ---缺省数据用什么填充</p>
<p>40 如何将数据写出到文本文件？</p>
<pre class="prettyprint linenums"><tt>numpy.</tt><tt>savetxt</tt><big>(</big>fname,&nbsp;X,&nbsp;fmt='%.18e',&nbsp;delimiter=' ',&nbsp;newline='\n',&nbsp;header='',&nbsp;footer='',&nbsp;comments='# '<big>)</big></pre>
<p><em>fname </em>---文件名<br />X      ---写出的数据表格</p>
<p><em>fmt='%.18e' &nbsp;&nbsp;</em>---数据格式</p>
<p>delimiter=',' &nbsp; ---分隔符逗号</p>
<p>newline='\n' &nbsp; ----换行</p>
<p><em>newline='\n' &nbsp; ---</em>-表头</p>
<p>footer='' &nbsp; &nbsp; &nbsp; &nbsp;----表尾</p>
<p>comments='# ' &nbsp; &nbsp;注释</p>
<p>41&nbsp;linspace和arange区别？</p>
<p>x = np.linspace(0, 4*np.pi, 100)   在0-4pi中间有100个点<br />x = np.arange(0, 4*np.pi, 2)       在0-4pi中间每两个点抽样一次</p>
<p>42 newaxis如何使用？</p>
<p>关于newaxis是很难理解的东西，而矩阵变换中又常用，这里用形式表现之：</p>
<p>1：a = array([A,B,C]) &nbsp; &nbsp; 这里ABC可能是数列，也可能是单独数，当使用a[：，newaxis]时，一定是如下格式：</p>
<p>将a中的最外层不管，将次外层看成独立元素，将他们加上&ldquo;[]&rdquo;，然后进行行排列</p>
<p>a[：，newaxis]等价于</p>
<p>[[A]，</p>
<p>[B]，</p>
<p>[C]]</p>
<p>2：a = array([A,B,C]) &nbsp; &nbsp; 这里ABC可能是数列，也可能是单独数，当使用a[newaxis，：]时，一定是如下格式：</p>
<p>在a上加外扩号：</p>
<p>a[newaxis，：] = array([ [A,B,C] ])</p>
<p>举例：</p>
<p>&gt;&gt;&gt;print a.shape</p>
<p>(3L, 3L)</p>
<p>b =&nbsp;a[:,newaxis]</p>
<p>&gt;&gt;&gt;print a[:,newaxis]</p>
<p>[[[0 1 3]]</p>
<p>[[4 5 6]]</p>
<p>[[7 8 9]]]</p>
<p>&gt;&gt;&gt;print b.shape</p>
<p>(3L, 1L, 3L) &nbsp; &nbsp; &nbsp; &nbsp;//意思为三行，每行是[1，3]的矩阵</p>
<p>当&nbsp;b =&nbsp;a[ newaxis，：]</p>
<p>&gt;&gt;&gt;print b<br />[[[0 1 3]<br />  [4 5 6]<br />  [7 8 9]]]</p>
<p>&gt;&gt;&gt;print b.shape</p>
<p>(1L, 3L, 3L) &nbsp; &nbsp; &nbsp; //意思为1行，内部是[3，3]的矩阵；</p>
<p>43 如何构造一个hilbert矩阵？</p>
<p>构造10X10的希尔伯特矩阵，参考第42问，第38问：</p>
<p>X = 1. / (np.arange(1, 11) + np.arange(0, 10)[:, np.newaxis])</p>
<p>44 何为logspace？</p>
<p>s = np.logspace(2.0, 3.0, num=3,base =4)</p>
<p>等价于</p>
<p>r =np.linspace(2,3,3)<br />l = 4**r</p>
<p>45 何为<tt>numpy.</tt><tt>meshgrid</tt><big>(</big><em>x</em>,&nbsp;<em>y</em><big>)？</big></p>
<p>用两个1维向量变换出两个矩阵X，Y，其规则如下：</p>
<p>对于向量&nbsp;<em>x</em>,&nbsp;<em>y</em>&nbsp;，长度&nbsp;<tt>Nx=len(x)</tt>&nbsp;和&nbsp;<tt>Ny=len(y)</tt>, 返回矩阵<em>X</em>,&nbsp;<em>Y</em>&nbsp;其中<em>X</em>&nbsp;和&nbsp;<em>Y</em>&nbsp;形状shape=&nbsp;<tt>(Ny,&nbsp;Nx)</tt>&nbsp;，填充数据为&nbsp;x的Ny重复, 后者为&nbsp;y的Nx次重复.</p>
<p>例：</p>
<pre class="prettyprint linenums">&gt;&gt;&gt; X, Y = np.meshgrid([1,2,3], [4,5,6,7])<br />
&gt;&gt;&gt; X<br />
array([[1, 2, 3],<br />
       [1, 2, 3],<br />
       [1, 2, 3],<br />
       [1, 2, 3]])<br />
&gt;&gt;&gt; Y<br />
array([[4, 4, 4],<br />
       [5, 5, 5],<br />
       [6, 6, 6],<br />
       [7, 7, 7]])</pre>
<p>46 何为mgrid？</p>
<p>也是一种从向量产生双矩阵的方法，如下：</p>
<p><strong>&gt;&gt;&gt; </strong>np.mgrid[0:5,0:5]<br />array([[[0, 0, 0, 0, 0],<br />[1, 1, 1, 1, 1],<br />[2, 2, 2, 2, 2],<br />[3, 3, 3, 3, 3],<br />[4, 4, 4, 4, 4]],<br />[[0, 1, 2, 3, 4],<br />[0, 1, 2, 3, 4],<br />[0, 1, 2, 3, 4],<br />[0, 1, 2, 3, 4],<br />[0, 1, 2, 3, 4]]])<br /><strong>&gt;&gt;&gt; </strong>np.mgrid[-1:1:5j]<br />array([-1. , -0.5, 0. , 0.5, 1. ])</p>
<p>47 如何<tt>numpy.</tt><tt>ravel</tt>实现矩阵扁平化？</p>
<p><tt><a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.ndarray.flat.html#numpy.ndarray.flat" rel="external nofollow noreferrer">例</a>：</tt></p>
<p>&gt;&gt;&gt; x = np.array([[1, 2, 3], [4, 5, 6]])<br />
&gt;&gt;&gt; print(np.ravel(x))<br />
[1 2 3 4 5 6]</p>
<p>48 如何理解np.nditer(a)？</p>
<p>请看代码：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; a = np.arange().reshape(,)<br />
&gt;&gt;&gt; for x in np.nditer(a):<br />
...     print x,<br />
...
     </pre>
</div>
<p>上述代码中，np.nditer(a)将a的元素扁平化后存入对象np.nditer中，然后读取出来，注意np.nditer不是个列表，是对象;不可用print  np.nditer(a)打印出来;用时要注意;</p>
<p>49 如何实现数组元素无差别函数变换？</p>
<p>所谓无差别函数操作就是将每一个元素按照同样变换方式，并写回;比如a中的元素都乘2，这是比较简单的变换，常规通过a *=2就能完成，但是变换如果很复杂，比如每个元素求自然对数，就无法简单表示，因此需要下列代码完成：</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; a = np.arange().reshape(,)<br />
&gt;&gt;&gt; a<br />
array([[, , ],<br />
       [, , ]])<br />
&gt;&gt;&gt; for x in np.nditer(a, <strong>op_flags=['readwrite'</strong>]):<br />
...    <strong> x[...] </strong>=  * x<br />
...<br />
&gt;&gt;&gt; a<br />
array([[ ,  ,  ],<br />
       [ ,  , ]])</pre>
</div>
<p>注意打开读写标志<strong>op_flags=['readwrite'</strong>]，x[...]不可写成x;因为x是从对象中读出的临时变量;而x[...]是当前临时变量x所面向的数组内地址，用以指明当前x写到哪里。</p>
<p>50 什么是<em>class </em><tt>numpy.</tt><tt>ndenumerate</tt><big>(</big><em>arr</em><big>)？</big></p>
<p><tt>ndenumerate</tt>和nditer类似，只是<tt>ndenumerate</tt>不返回元素的值，返回的全是下标;下标有两组，一组是数组的（Nx和Ny）另一组是nditer的顺序标号;与nditer同，不可用print&nbsp;np.ndenumerate(a)打印;</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; a = np.arange(6).reshape(2,3)

&gt;&gt;&gt; for index, x in np.ndenumerate(a):<br />&nbsp;&nbsp;&nbsp; ...:&nbsp;&nbsp;&nbsp;&nbsp; print(index, x)<br />&nbsp;&nbsp;&nbsp; ...:&nbsp;&nbsp; &nbsp;<br />((0, 0), 0)<br />((0, 1), 1)<br />((0, 2), 2)<br />((1, 0), 3)<br />((1, 1), 4)<br />((1, 2), 5)</pre>
</div>
<p>51 如何理解np的mean函数的axis？</p>
<p>关于numpy mean函数的axis参数，理解多维矩阵的"求和"、"平均"操作确实太恶心了，numpy提供的函数里还有一堆参数，搞得晕头转向的，这里做个笔记，提醒一下自己， 下面是例程</p>
<div>
<pre class="prettyprint linenums"><code>import numpy as np<br />
X = np.array([[1, 2], [4, 5], [7, 8]])<br />
print np.mean(X, axis=0, keepdims=True)<br />
print np.mean(X, axis=1, keepdims=True)</code></pre>
<p>结果是分别是</p>
<pre class="prettyprint linenums"><code>                 [[ 1.5]<br />
 [[ 4.  5.]]      [ 4.5]<br />
                  [ 7.5]]</code></pre>
<p>我个人比较raw的认识就是，axis=0，那么输出矩阵是1行，求每一列的平均（按照每一行去求平均）；axis=1，输出矩阵是1列，求每一行的平均（按照每一列去求平均）。还可以这么理解，axis是几，那就表明哪一维度被压缩成1。</p>
<p>再举个更复杂点的例子，比如我们输入为batch = [128, 28, 28]，可以理解为batch=128，图片大小为28&times;28像素，我们相求这128个图片的均值，应该这么写</p>
<pre class="prettyprint linenums"><code>m = np.mean(batch, axis=0)</code></pre>
<p>输出结果m的shape为(28,28)，就是这128个图片在每一个像素点平均值。</p>
<p>52 矩阵相关计算如何实现？</p>
<p>1）定义：</p>
<div>
<pre class="prettyprint linenums">a = np.matrix([     [, , , ],<br />
                             [, , , ],<br />
                             [, , , ],<br />
                              [, , , ]       ])</pre>
</div>
<p>2）加法减法</p>
<div>
<div>　　　　#矩阵加减法：</div>
<div>　　　　e = a + a 　　#or&nbsp;&nbsp; 　e = a - a</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; e = a + a转置&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#or&nbsp;&nbsp; 　e = a.转置+ a&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; a为向量时这里转置是 a[：，np.newaxis ] 这个语法，切记之</div>
<div>&nbsp;&nbsp;&nbsp; 3）乘法</div>
<div>
<div>
<pre class="prettyprint linenums">#矩阵乘法:<br />
b = a * a                 #not matrix multiplication!<br />
#or<br />
c = np.dot(a, a)          #matrix multiplication<br />
#or<br />
d = a<br />
np.dot(a, a, d)           #matrix multiplication</pre>
</div>
<div>&nbsp;&nbsp;&nbsp; 4）转置矩阵(transpose)</div>
<div>　　g = a.transpose() 或h = a.T 等价</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp; 5）逆矩阵(inverse)</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; f = np.linalg.inv(a)&nbsp; 　或&nbsp;&nbsp;&nbsp; f = a.I</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; f = a ** (-1)&nbsp; 求各元素倒数，不是求逆</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 6）行列式(determinant)</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; j = np.linalg.det(a)</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;7）伴随矩阵(adjoint)</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; #(need more test)</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; m = np.dot(np.linalg.det(a), np.linalg.inv(a)) # A<sup>-1</sup> = A<sup>''</sup> / |A| &nbsp;==&gt;&nbsp;&nbsp;&nbsp;A<sup>''</sup>=&nbsp;A<sup>-1</sup>|A| &nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp; 8）矩阵范数(matrix norms)</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; k = np.linalg.norms(a)</div>
</div>
<div>&nbsp;53 如何初始化矩阵？</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Python使用NumPy包完成了对N-维数组的快速便捷操作。使用这个包，需要导入numpy。 SciPy包以NumPy包为基础，大大的扩展了numpy的能力。为了使用的方便，scipy包在最外层名字空间中包括了所有的numpy内容，因此只要导入了scipy，不必在单独导入numpy了！但是为了明确哪些是numpy中实现的，哪些是scipy中实现的，本文还是进行了区分。以下默认已经：import numpy as np 以及 impor scipy as sp</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 下面简要介绍Python和MATLAB处理数学问题的几个不同点。1.MATLAB的基本是矩阵，而numpy的基本类型是多为数组，把matrix看做是array的子类。2.MATLAB的索引从1开始，而numpy从0开始。</div>
<div><strong>1.建立矩阵</strong></div>
<div>a1=np.array([1,2,3],dtype=int)&nbsp;&nbsp;&nbsp;#建立一个一维数组，数据类型是int。也可以不指定数据类型，使用默认。几乎所有的数组建立函数都可以指定数据类型，即dtype的取值。</div>
<div>a2=np.array([[1,2,3],[2,3,4]])&nbsp;&nbsp;&nbsp;#建立一个二维数组。此处和MATLAB的二维数组（矩阵）的建立有很大差别。</div>
<div>同样，numpy中也有很多内置的特殊矩阵：</div>
<div>b1=np.zeros((2,3))&nbsp;&nbsp;&nbsp;&nbsp;#生成一个2行3列的全0矩阵。注意，参数是一个tuple：(2,3)，所以有两个括号。完整的形式为：zeros(shape,dtype=)。相同的结构，有<strong>ones()</strong>建立全1矩阵。<strong>empty()</strong>建立一个空矩阵，使用内存中的随机值来填充这个矩阵。</div>
<div>b2=identity(n)&nbsp;&nbsp;&nbsp;#建立n*n的单位阵，这只能是一个方阵。</div>
<div>b3=eye(N,M=None,k=0)&nbsp;&nbsp;&nbsp;&nbsp;#建立一个对角线是1其余值为0的矩阵，用k指定对角线的位置。M默认None。</div>
<div>此外，numpy中还提供了几个like函数，即按照某一个已知的数组的规模（几行几列）建立同样规模的特殊数组。这样的函数有<strong>zeros_like()、empty_like()、ones_like()，</strong>它们的参数均为如此形式：zeros_like(a,dtype=)，其中，a是一个已知的数组。</div>
<div>c1=np.arange(2,3,0.1)&nbsp;&nbsp;&nbsp;#起点，终点，步长值。含起点值，不含终点值。</div>
<div>c2=np.linspace(1,4,10)&nbsp;&nbsp;&nbsp;&nbsp;#起点，终点，区间内点数。起点终点均包括在内。同理，有logspace()函数</div>
<div>d1=np.linalg.companion(a)&nbsp;&nbsp;&nbsp;&nbsp;#伴随矩阵</div>
<div>d2=np.linalg.triu()/tril()&nbsp;&nbsp;&nbsp;#作用同MATLAB中的同名函数</div>
<div>e1=np.random.rand(3,2)&nbsp;&nbsp;&nbsp;&nbsp;#产生一个3行2列的随机数组。同一空间下，有randn()/randint()等多个随机函数</div>
<div>fliplr()/flipud()/rot90()&nbsp;&nbsp;&nbsp;&nbsp;#功能类似MATLAB同名函数。</div>
<div>xx=np.roll(x,2)&nbsp;&nbsp;&nbsp;#roll()是循环移位函数。此调用表示向右循环移动2位。</div>
<div><strong>2.数组的特征信息</strong></div>
<div>先假设已经存在一个N维数组X了，那么可以得到X的一些属性，这些属性可以在输入X和一个.之后，按tab键查看提示。这里明显看到了Python面向对象的特征。</div>
<div>X.flags&nbsp;&nbsp;&nbsp;&nbsp;#数组的存储情况信息。</div>
<div>X.shape&nbsp;&nbsp;&nbsp;&nbsp;#结果是一个tuple，返回本数组的行数、列数、&hellip;&hellip;</div>
<div>X.ndim&nbsp;&nbsp;&nbsp;#数组的维数，结果是一个数</div>
<div>X.size&nbsp;&nbsp;&nbsp;&nbsp;#数组中元素的数量</div>
<div>X.itemsize&nbsp;&nbsp;&nbsp;&nbsp;#数组中的数据项的所占内存空间大小</div>
<div>X.dtype&nbsp;&nbsp;&nbsp;&nbsp;#数据类型</div>
<div>X.T&nbsp;&nbsp;&nbsp;#如果X是矩阵，发挥的是X的转置矩阵</div>
<div>X.trace()&nbsp;&nbsp;&nbsp;&nbsp;#计算X的迹</div>
<div>np.linalg.det(a)&nbsp;&nbsp;&nbsp;#返回的是矩阵a的行列式</div>
<div>np.linalg.norm(a,ord=None)&nbsp;&nbsp;&nbsp;&nbsp;#计算矩阵a的范数</div>
<div>np.linalg.eig(a)&nbsp;&nbsp;&nbsp;&nbsp;#矩阵a的特征值和特征向量</div>
<div>np.linalg.cond(a,p=None)&nbsp;&nbsp;&nbsp;&nbsp;#矩阵a的条件数</div>
<div>np.linalg.inv(a)&nbsp;&nbsp;&nbsp;&nbsp;#矩阵a的逆矩阵</div>
<div><strong>3.矩阵分解</strong></div>
<div>常见的矩阵分解函数，numpy.linalg均已经提供。比如cholesky()/qr()/svd()/lu()/schur()等。某些<a href="http://lib.csdn.net/base/datastructure" rel="external nofollow noreferrer">算法</a>为了方便计算或者针对不同的特殊情况，还给出了多种调用形式，以便得到最佳结果。</div>
<div><strong>4.矩阵运算</strong></div>
<div>np.dot(a,b)用来计算数组的点积；vdot(a,b)专门计算矢量的点积，和dot()的区别在于对complex数据类型的处理不一样；innner(a,b)用来计算内积；outer(a,b)计算外积。</div>
<div>专门处理矩阵的数学函数在numpy的子包linalg中定义。比如 np.linalg.logm(A)计算矩阵A的对数。可见，这个处理和MATLAB是类似的，使用一个m后缀表示是矩阵的运算。在这个空间内可以使用的有cosm()/sinm()/signm()/sqrtm()等。其中常规exp()对应有三种矩阵形式：expm()使用Pade近似算法、 expm2()使用特征值分析算法、expm3()使用泰勒级数算法。在numpy中，也有一个计算矩阵的函数：funm(A,func)。</div>
<div><strong>5.索引</strong></div>
<div>numpy中的数组索引形式和Python是一致的。如：</div>
<div>x=np.arange(10)</div>
<div>print x[2]&nbsp;&nbsp;&nbsp;&nbsp;#单个元素，从前往后正向索引。注意下标是从0开始的。</div>
<div>print x[-2]&nbsp;&nbsp;&nbsp;&nbsp;#从后往前索引。最后一个元素的下标是-1</div>
<div>print x[2:5]&nbsp;&nbsp;&nbsp;&nbsp;#多个元素，左闭右开，默认步长值是1</div>
<div>print x[:-7]&nbsp;&nbsp;&nbsp;&nbsp;#多个元素，从后向前，制定了结束的位置，使用默认步长值</div>
<div>print x[1:7:2]&nbsp;&nbsp;&nbsp;#指定步长值</div>
<div>x.shape=(2,5)&nbsp;&nbsp;&nbsp;&nbsp;#x的<strong>shape</strong>属性被重新赋值，要求就是元素个数不变。2*5=10</div>
<div>print x[1,3]&nbsp;&nbsp;&nbsp;&nbsp;#二维数组索引单个元素，第2行第4列的那个元素</div>
<div>print x[0]&nbsp;&nbsp;&nbsp;#第一行所有的元素</div>
<div>y=np.arange(35).reshape(5,7)&nbsp;&nbsp;&nbsp;&nbsp;#<strong>reshape()</strong>函数用于改变数组的维度</div>
<div>print y[1:5:2,::2]&nbsp;&nbsp;&nbsp;&nbsp;#选择二维数组中的某些符合条件的元素</div>
</div>
<div><a>QQ空间</a><a>QQ好友</a><a>新浪微博</a><a>腾讯微博</a><a>推荐给朋友</a></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>54 矩阵加法的注意事项？</div>
<div>
<div>
<pre class="prettyprint linenums">a =np.array([,,,,])<br />
s =np.array([[],[],[]])<br />
print( a )<br />
print (s)<br />
print(a+s)   #此处a和s可以交换</pre>
</div>
<p>结果：<br />&nbsp;[1 3 4 5 6]<br />&nbsp;[[13]<br />&nbsp;[ 4]<br />&nbsp;[ 6]]<br />&nbsp;[[14 16 17 18 19]<br />&nbsp;[ 5&nbsp; 7&nbsp; 8&nbsp; 9 10]<br />&nbsp;[ 7&nbsp; 9 10 11 12]]</p>
<p>55 logspace指数序列的产生？</p>
<p>&gt;&gt;&gt; a = np.logspace(0,9,10,base=2)<br />&gt;&gt;&gt; a<br />array([ &nbsp; 1., &nbsp; &nbsp;2., &nbsp; &nbsp;4., &nbsp; &nbsp;8., &nbsp; 16., &nbsp; 32., &nbsp; 64., &nbsp;128., &nbsp;256., &nbsp;512.])</p>
<p>每一项的形态是base=2的0-9次方序列</p>
<p>56 numpy如何产生等比数列？</p>
<div>
<pre class="prettyprint linenums">import numpy as np<br />np.logspace(2.0, 3.0, num=4)<br />
array([  100.        ,   215.443469  ,   464.15888336,  1000.        ])</pre>
</div>
<p>57 如何生成复杂矩阵？</p>
<p>通过形式函数是现，比如：</p>
<div>
<pre class="prettyprint linenums"> b = np.fromfunction(lambda x,y,z:x*100+y*10+z,(3,3,3),dtype=int)
</pre>
</div>
<p>58 如何遍历数组？</p>
<p>分三个办法：</p>
<p>第一种，最常用的，通过for in遍历数组</p>
<div>
<pre class="prettyprint linenums">colours = ["red","green","blue"]

for colour in colours:<br />
    print colour
</pre>
</div>
<p>第二种，先获得数组的长度，然后根据索引号遍历数组，同时输出索引号</p>
<div>
<pre class="prettyprint linenums">colours = ["red","green","blue"]<br />
 for i in range(0, len(colours)):<br />
print i, colour[i]
</pre>
</div>
<p>第三种 通过迭代器完成</p>
<div>
<pre class="prettyprint linenums"> for element in b.flat:<br />
        print element,     </pre>
</div>
<p>59 如何定义等距序列numpy.linspace？</p>
<p>函数原型numpy.linspace(start, stop, num=50, endpoint=True, retstep=False, dtype=None)</p>
<p>start : scalar(标量值)，表明序列起始数</p>
<p>stop : scalar(标量值)，序列终结位置，&nbsp;若endpoint=True，序列包含end；若endpoint=False，序列不包含end；</p>
<p>　　num：int 序列中元素个数</p>
<p>endpoint : bool 如果是真，则一定包括stop，如果为False，一定不会有stop</p>
<p>retstep : bool 如果真，将间隔步长也返回，否则，不返回步长</p>
<p>dtype：数据的类型（int32，float32）</p>
<p>实例：</p>
<div>&gt;&gt;&gt; import numpy as np</div>
<div>&gt;&gt;&gt; np.linspace(1, 10, 10)</div>
<div>array([ &nbsp;1., &nbsp; 2., &nbsp; 3., &nbsp; 4., &nbsp; 5., &nbsp; 6., &nbsp; 7., &nbsp; 8., &nbsp; 9., &nbsp;10.])</div>
<div>&gt;&gt;&gt; np.linspace(1, 10, 10, endpoint = False)</div>
<div>array([ 1. , &nbsp;1.9, &nbsp;2.8, &nbsp;3.7, &nbsp;4.6, &nbsp;5.5, &nbsp;6.4, &nbsp;7.3, &nbsp;8.2, &nbsp;9.1])</div>
<div>In [4]: np.linspace(1, 10, 10, endpoint = False, retstep= True)</div>
<div>Out[4]: (array([ 1. , &nbsp;1.9, &nbsp;2.8, &nbsp;3.7, &nbsp;4.6, &nbsp;5.5, &nbsp;6.4, &nbsp;7.3, &nbsp;8.2, &nbsp;9.1]), 0.9)</div>
<div>&nbsp;</div>
<div>&nbsp;60 向量和矩阵的关系（newaxis改变）？</div>
<p>向量无论如何转置，都是它本身；如：</p>
<pre class="prettyprint linenums">s_data = np.linspace(-1,1,30) <br />r_data = np.transpose(s_data)

<strong>在此，s_data和r_data 两个向量完全一样。而

</strong>x_data = np.linspace(-1,1,30)[:,np.newaxis]<br />y_data = np.linspace(-1,1,30)[np.newaxis,:]<br />就成了[30X1]和[1X30]的矩阵。

61 如何求矩阵的逆矩阵？<br />A = np.array( [[1,-2,1],[0,2,-1],[1,1,-2]] ) <br />B = np.linalg.inv( A ) <br />print(B)

62 求矩阵行列式<br />A = np.array( [[1,-2,1],[0,2,-1],[1,1,-2]] ) <br />B = np.linalg.det( A ) <br />print(B)

63 获取张量的最小量对应的序号<br />当axis=None时，为张量展开成一维单列的序号，否则就是行向，或列向的若干序号。</pre>
<div>
<pre class="prettyprint linenums">a = np.array([ [,,],<br />
               [,,],<br />
               [,,]])<br />
print(np.argmin(a,axis=None))</pre>
</div>
<pre class="prettyprint linenums">64  将某个张量矩阵写成二进制的位张量np.unpackbits</pre>
<pre class="prettyprint linenums">a = np.array([[2], [7], [23]], dtype=np.uint8)</pre>
<pre class="prettyprint linenums">&gt;&gt;&gt; a<br />
array([[ 2],<br />
       [ 7],<br />
       [23]], dtype=uint8)<br />
b = np.unpackbits(a, axis=1)<br />
&gt;&gt;&gt; b<br />
array([[0, 0, 0, 0, 0, 0, 1, 0],<br />
       [0, 0, 0, 0, 0, 1, 1, 1],<br />
       [0, 0, 0, 1, 0, 1, 1, 1]], dtype=uint8)</pre>
<pre class="prettyprint linenums">65  将某个张量改变形状，但数值不变<br /><code>numpy.</code><code>reshape</code>(<em>a</em>,&nbsp;<em>newshape</em>,&nbsp;<em>order='C'</em>)</pre>
<div>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; a = np.array([[1,2,3], [4,5,6]])<br />
&gt;&gt;&gt; np.reshape(a, 6)<br />
array([1, 2, 3, 4, 5, 6])<br />
&gt;&gt;&gt; np.reshape(a, 6, order='F')<br />
array([1, 4, 2, 5, 3, 6])
</pre>
</div>
</div>
<pre class="prettyprint linenums"></pre>
<div>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; np.reshape(a, (3,-1))       # the unspecified value is inferred to be 2<br />
array([[1, 2],<br />
       [3, 4],<br />
       [5, 6]])
</pre>
</div>
</div>
<pre class="prettyprint linenums">66 <a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.reshape.html" rel="external nofollow noreferrer">numpy.matrix系列</a>函数</pre>
<table>
<tbody>
<tr>
<td><a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.matrix.T.html#numpy.matrix.T" rel="external nofollow noreferrer"><code>matrix.T</code></a></td>
<td>Returns the transpose of the matrix.</td>
</tr>
<tr>
<td><a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.matrix.H.html#numpy.matrix.H" rel="external nofollow noreferrer"><code>matrix.H</code></a></td>
<td>Returns the (complex) conjugate transpose of&nbsp;<em>self</em>.</td>
</tr>
<tr>
<td><a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.matrix.I.html#numpy.matrix.I" rel="external nofollow noreferrer"><code>matrix.I</code></a></td>
<td>Returns the (multiplicative) inverse of invertible&nbsp;<em>self</em>.</td>
</tr>
<tr>
<td><a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.matrix.A.html#numpy.matrix.A" rel="external nofollow noreferrer"><code>matrix.A</code></a></td>
<td>Return&nbsp;<em>self</em>&nbsp;as an&nbsp;<a href="https://docs.scipy.org/doc/numpy/reference/generated/numpy.ndarray.html#numpy.ndarray" rel="external nofollow noreferrer"><code>ndarray</code></a>&nbsp;object.</td>
</tr>
</tbody>
</table>
<pre class="prettyprint linenums">67  内存和文件的映射</pre>
<h2>　<a href="https://docs.scipy.org/doc/numpy/reference/arrays.classes.html#record-arrays-numpy-rec" rel="external nofollow noreferrer">　Memory-mapped file arrays</a></h2>
<pre class="prettyprint linenums">&gt;&gt;&gt; a = memmap('newfile.dat', dtype=float, mode='w+', shape=1000)<br />
&gt;&gt;&gt; a[10] = 10.0<br />
&gt;&gt;&gt; a[30] = 30.0<br />
&gt;&gt;&gt; del a<br />
&gt;&gt;&gt; b = fromfile('newfile.dat', dtype=float)<br />
&gt;&gt;&gt; print b[10], b[30]<br />
10.0 30.0<br />
&gt;&gt;&gt; a = memmap('newfile.dat', dtype=float)<br />
&gt;&gt;&gt; print a[10], a[30]<br />
10.0 30.0
</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
<pre class="prettyprint linenums">

</pre>
<div>
<div>
<div><a href="http://www.2cto.com/kf/201412/357284.html#" rel="external nofollow noreferrer">?</a></div>
</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gr430q.html">&dollar;&period;when&lpar;deferreds&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyo0ed8.html">RCC BUCK-BOOST变压器设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmvod8.html">《深入理解bootstrap》读书笔记：第4章 CSS组件（下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4954576q.html">css absolute与relative的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnr21k9.html">python实现查找指定文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wdevoq.html">C&plus;&plus;智能指针管理类</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vmjl38.html">PHP安装编译配置参考</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjvo5l8.html">Facebook HHVM 和 Hack 手册----1&period;什么是Hack？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdkp6k9.html">CodeForces 598E Chocolate Bar</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pdk048.html">echarts&lowbar;部分图表配置&lowbar;dataZoom精确控制显示数据数量</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zw3xe9.html">freemarker写select组件报错总结（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jz50o8.html">registration&lowbar;db&period;go</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zlxr59.html">App功能测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv25jlz9.html">《剑指offer》总结三 之二叉树（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r54nyrq.html">MongoDB&mdash;&mdash;待整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj555z9.html">numpy快速入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgkpz8.html">ubuntu安装python3&period;6</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2okmy9.html">The connection to adb is down&comma; and a severe error has occured&lpar;Android模拟器端口被占用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rzelj9.html">webpack相关配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjp3v7q.html">ArcGisServer根据最大最小坐标换算瓦片行列号【转】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49g5y1l8.html">Java ResourceBundle类的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96ywln8.html">Linux  uniq常用命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4koz59.html">&lbrack;PHP&rsqb; - Laravel - 修改laravel&lowbar;session的cookie名称</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvrymz8.html">linux---mysql安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvryyj8.html">Netty系列之Netty百万级推送服务设计要点</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93v44r8.html">eclipse的常用快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy5k2m9.html">mybatis实战教程&lpar;mybatis in action&rpar;之六：与Spring MVC 的集成</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1l3j28.html">安装ntp</a>
			</li>
						<li><a href="https://www.batexi.com/a/495w2jm9.html">Html5上传后有所见图片效果前端代码实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvr4rx8.html">PHP网页显示乱码问题总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
